# 2014.04.25 10:27:17 Jordan Daylight Time

from .picplayer import sgrabberPic_Thumb
from Components.AVSwitch import AVSwitch
from Components.ActionMap import ActionMap
from Components.ConfigList import ConfigListScreen
from Components.Label import Label
from Components.MenuList import MenuList
from Components.Pixmap import Pixmap
from Components.Sources.StaticText import StaticText
from Components.config import config, ConfigSelection, getConfigListEntry, configfile
from GlobalActions import globalActionMap
from Plugins.Plugin import PluginDescriptor
from Screens.MessageBox import MessageBox
from Screens.Screen import Screen
from Screens.Standby import TryQuitMainloop
from ServiceReference import ServiceReference
from Tools.Directories import fileExists, copyfile
from enigma import getDesktop, ePicLoad
from keymapparser import readKeymap
from keymapparser import readKeymap, removeKeymap
from os import path, listdir, remove, makedirs

currversion = '2.6'
config.sgrabber = ConfigSubsection()
config.plugins.sgrabber = ConfigSubsection()
config.plugins.sgrabber.items = ConfigSelection(default='Disabled', choices=[('All', _('Grab All')),
                                                ('-v', _('Video only')),
                                                ('-o', _('OSD only')),
                                                ('Disabled', _('Off'))])
config.plugins.sgrabber.storedir = ConfigSelection(default='tmp', choices=[('tmp', _('/tmp')), ('hdd', _('/media/hdd')), ('usb', _('/media/usb'))])
config.plugins.sgrabber.scut = ConfigSelection(default='text', choices=[('text', _('Text')),
                                                                        ('help', _('Help')),
                                                                        ('info', _('Info')),
                                                                        ('green', _('Long green')),
                                                                        ('red', _('Long red')),
                                                                        ('video', _('Video')),
                                                                        ('mute', _('Mute')),
                                                                        ('radio', _('Radio'))])
config.plugins.sgrabber.newsize = ConfigSelection(default='-r800', choices=[('-r1920', _('1920*1080')),
                                                                            ('-r800', _('800*450')),
                                                                            ('-r600', _('600*337')),
                                                                            ('Disabled', _('Skin resolution'))])
config.plugins.sgrabber.format = ConfigSelection(default='-j80', choices=[('-j100', _('jpg100')),
                                                                          ('-j80', _('jpg80')),
                                                                          ('-j60', _('jpg60')),
                                                                          ('-j40', _('jpg40')),
                                                                          ('-j20', _('jpg20')),
                                                                          ('-p', _('PNG'))])
config.plugins.sgrabber.fixedaspectratio = ConfigSelection(default='Disabled', choices=[('-n', _('Enabled')), ('Disabled', _('Off'))])
config.plugins.sgrabber.always43 = ConfigSelection(default='Disabled', choices=[('-l', _('Enabled')), ('Disabled', _('Off'))])
config.plugins.sgrabber.bicubic = ConfigSelection(default='Disabled', choices=[('-b', _('Enabled')), ('Disabled', _('Off'))])


def makedir(path):
    try:
        makedirs(path)
        return True
    except:
        return False


class sgrabberFilesScreen(Screen):
    # skin = '\n                        <screen name="sgrabberFilesScreen" position="center,center" size="640,520" title="Screenshot Files"  flags="wfNoBorder" >\n                        <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/framesd.png" position="0,0" size="640,520"/>\t\t\n\t\n\t\t\t<ePixmap position="15,65" size="610,5" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/slider.png" alphatest="blend" transparent="1" backgroundColor="transparent"/>\n\t\t\n                          <widget name="ButtonBluetext" position="75,25" size="160,40" valign="center" halign="left" zPosition="10" font="Regular;22" transparent="1" />\n\t\t\t  <widget name="ButtonBlue" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/button_blue.png" position="55,35" zPosition="10" size="100,100" transparent="1" alphatest="on" />\n                          <widget name="ButtonYellowtext" position="285,25" size="200,40" valign="center" halign="left" zPosition="10" font="Regular;22" transparent="1" />\n\t\t\t  <widget name="ButtonYellow" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/button_yellow.png" position="265,35" zPosition="10" size="100,100" transparent="1" alphatest="on" />\n                          <widget name="info" position="25,415" zPosition="4" size="400,30" font="Regular;20" foregroundColor="yellow" transparent="1" halign="left" valign="center" />\n                          <widget name="menu" position="30,75" size="580,425" scrollbarMode="showOnDemand" transparent="1" zPosition="2" />\n\t                  \n        \t</screen>\n\t\t'
    skin = '''<screen name="sgrabberFilesScreen" position="center,center" size="1280,720" title="Screenshot Files" flags="wfNoBorder">
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/framesd.png" position="0,0" scale="stretch" size="1280,720" />
                <ePixmap position="40,60" size="600,6" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/slider.png" alphatest="blend" transparent="1" backgroundColor="transparent" />
                <widget name="menu" position="42,72" size="600,500" scrollbarMode="showOnDemand" transparent="1" zPosition="2" itemHeight="50" />
                <widget name="info" position="44,581" zPosition="4" size="1189,55" font="Regular;28" foregroundColor="yellow" transparent="1" halign="center" valign="center" />
                <eLabel backgroundColor="#00ffff00" position="638,680" size="300,6" zPosition="12" />
                <eLabel backgroundColor="#000000ff" position="939,680" size="300,6" zPosition="12" />
                <widget source="ButtonYellowtext" render="Label" position="638,640" size="300,45" zPosition="11" font="Regular; 30" valign="center" halign="center" backgroundColor="background" transparent="1" foregroundColor="white" />
                <widget source="ButtonBluetext" render="Label" position="939,640" size="300,45" zPosition="11" font="Regular; 30" valign="center" halign="center" backgroundColor="background" transparent="1" foregroundColor="white" />
            </screen>'''

    def __init__(self, session):
        self.skin = sgrabberFilesScreen.skin
        Screen.__init__(self, session)
        list = []
        self['menu'] = MenuList(list)
        self['ButtonBluetext'] = Label(_('Preview'))
        self['ButtonYellowtext'] = Label(_('Delete'))
        self['info'] = Label()
        if config.plugins.sgrabber.storedir.value == 'tmp':
            self.folder = '/tmp/screenshots/'
        elif config.plugins.sgrabber.storedir.value == 'usb':
            self.folder = '/media/usb/screenshots/'
        else:
            self.folder = '/media/hdd/screenshots/'
        self['actions'] = ActionMap(['SetupActions', 'ColorActions'], {'yellow': self.removefile,
                                                                       'blue': self.onFileAction,
                                                                       'ok': self.onFileAction,
                                                                       'cancel': self.close}, -2)
        self.fillplgfolders()

    def removefile(self):
        self['info'].setText('')
        try:
            fname = self['menu'].getCurrent()
            filename = self.folder + fname
            remove(filename)
            self.fillplgfolders()
        except:
            self['info'].setText('unable to delete file')

    def onFileAction(self):
        self['info'].setText('')
        # fname = self['menu'].getCurrent()
        try:
            self.session.open(sgrabberPic_Thumb, self.fullpath, 0, self.folder)
        except TypeError as e:
            self['info'].setText('unable to preview file')
            print('error:', e)

    def fillplgfolders(self):
        self['info'].setText('')
        plgfolders = []
        fullpath = []
        print("112"), self.folder
        if path.exists(self.folder):
            for x in listdir(self.folder):
                if path.isfile(self.folder + x):
                    if x.endswith('.jpg') or x.endswith('.png') or x.endswith('.bmp') or x.endswith('.gif'):
                        plgfolders.append(x)
                        fullpath.append(x)

        self['menu'].setList(plgfolders)
        self.fullpath = fullpath


class sgrabberScreenGrabberSetup(Screen, ConfigListScreen):
    # skin = '\n                        <screen name="sgrabberScreenGrabberSetup" position="center,center" size="640,520" title="ScreebGrabber setup"  flags="wfNoBorder" >\n                        <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/framesd.png" position="0,0" size="640,520"/>\t\t\n\t\t \n\t\t\t<ePixmap position="15,45" size="610,5" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/slider.png" alphatest="blend" transparent="1" backgroundColor="transparent"/>\n\t\t\t<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/button_red.png" position="20,15" zPosition="0" size="140,40" transparent="1" alphatest="on" />\n\t\t\t<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/button_green.png" position="160,15" zPosition="0" size="140,40" transparent="1" alphatest="on" />\n\t\t\t<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/button_yellow.png" position="300,15" zPosition="0" size="140,40" transparent="1" alphatest="on" />\n\t\t\t\n\t\t\t<widget render="Label" source="key_red" position="40,5" size="140,40" zPosition="5" valign="center" halign="left" backgroundColor="red" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget render="Label" source="key_green" position="180,5" size="140,40" zPosition="5" valign="center" halign="left" backgroundColor="red" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget render="Label" source="key_yellow" position="320,5" size="140,40" zPosition="5" valign="center" halign="left" backgroundColor="red" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n                        <widget name="config" position="20,50" size="600,320" scrollbarMode="showOnDemand" transparent="1" zPosition="2" />\n\t\t        <widget name="info" position="0,370" zPosition="4" size="580,30" font="Regular;20" foregroundColor="yellow" transparent="1" halign="center" valign="center" />\n                </screen>'
    skin = '''<screen name="sgrabberScreenGrabberSetup" position="center,center" size="1280,720" title="ScreebGrabber setup" flags="wfNoBorder">
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/framesd.png" position="0,0" scale="stretch" size="1280,720" />
                <ePixmap position="40,60" size="600,6" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/images/slider.png" alphatest="blend" transparent="1" backgroundColor="transparent" />
                <widget name="config" position="42,72" size="600,500" scrollbarMode="showOnDemand" transparent="1" zPosition="2" itemHeight="50" />
                <widget name="info" position="41,578" zPosition="4" size="1189,55" font="Regular;28" foregroundColor="yellow" transparent="1" halign="center" valign="center" />
                <eLabel backgroundColor="#00ff0000" position="39,680" size="300,6" zPosition="12" />
                <eLabel backgroundColor="#0000ff00" position="337,680" size="300,6" zPosition="12" />
                <eLabel backgroundColor="#00ffff00" position="638,680" size="300,6" zPosition="12" />
                <eLabel backgroundColor="#000000ff" position="939,680" size="300,6" zPosition="12" />
                <widget source="key_red" render="Label" position="37,640" size="300,45" zPosition="11" font="Regular; 30" valign="center" halign="center" backgroundColor="background" transparent="1" foregroundColor="white" />
                <widget source="key_green" render="Label" position="338,640" size="300,45" zPosition="11" font="Regular; 30" valign="center" halign="center" backgroundColor="background" transparent="1" foregroundColor="white" />
                <widget source="key_yellow" render="Label" position="638,640" size="300,45" zPosition="11" font="Regular; 30" valign="center" halign="center" backgroundColor="background" transparent="1" foregroundColor="white" />
                <widget source="key_blue" render="Label" position="939,640" size="300,45" zPosition="11" font="Regular; 30" valign="center" halign="center" backgroundColor="background" transparent="1" foregroundColor="white" />
            </screen>'''

    def __init__(self, session):
        Screen.__init__(self, session)
        self['key_red'] = StaticText(_('Cancel'))
        self['key_green'] = StaticText(_('Save'))
        self['key_yellow'] = StaticText(_('Files'))
        self['info'] = Label('ScreenGrabber V.%s mfaraj' % currversion)
        self.list = []
        self.list.append(getConfigListEntry(_('ScreenShot:'), config.plugins.sgrabber.items))
        self.list.append(getConfigListEntry(_('Storing Folder:'), config.plugins.sgrabber.storedir))
        self.list.append(getConfigListEntry(_('Remote screenshot button:'), config.plugins.sgrabber.scut))
        self.list.append(getConfigListEntry(_('Picture size:'), config.plugins.sgrabber.newsize))
        self.list.append(getConfigListEntry(_('screenshot format/quality:'), config.plugins.sgrabber.format))
        self.list.append(getConfigListEntry(_('Fixed Aspect ratio:'), config.plugins.sgrabber.fixedaspectratio))
        self.list.append(getConfigListEntry(_('Fixed Aspect ratio 4:3:'), config.plugins.sgrabber.always43))
        self.list.append(getConfigListEntry(_('Bicubic picture resize:'), config.plugins.sgrabber.bicubic))
        self.onitem = config.plugins.sgrabber.items.value
        self.scut = config.plugins.sgrabber.scut.value
        ConfigListScreen.__init__(self, self.list, session)
        self['setupActions'] = ActionMap(['SetupActions', 'ColorActions'], {'yellow': self.showfiles,
                                                                            'green': self.keySave,
                                                                            'cancel': self.keyClose}, -2)

    def showfiles(self):
        if self.checkfolder() is True:
            self.session.open(sgrabberFilesScreen)
        else:
            self.session.open(MessageBox, text=_('Storing directory is not available'), type=MessageBox.TYPE_INFO, timeout=3, close_on_any_key=True)

    def checkfolder(self):
        strfolder = str(self['config'].list[1][1].value)
        print(strfolder)
        if strfolder == 'hdd':
            strfolder = '/media/hdd'
        elif strfolder == 'tmp':
            strfolder = '/tmp'
        elif strfolder == 'usb':
            strfolder = '/media/usb'
        else:
            return False
        print(strfolder)
        if path.exists(strfolder):
            return True
        else:
            return False

    def keySave(self):
        if self.checkfolder() is True:
            for x in self['config'].list:
                x[1].save()

            configfile.save()
            if not self.onitem == config.plugins.sgrabber.items.value or not self.scut == config.plugins.sgrabber.scut.value:
                self.session.openWithCallback(self.restartenigma, MessageBox, _('Restart enigma2 to load new settings?'), MessageBox.TYPE_YESNO)
            else:
                self.close(True)
        else:
            self.session.open(MessageBox, text=_('Storing directory is not available'), type=MessageBox.TYPE_INFO, timeout=3, close_on_any_key=True)
            return

    def restartenigma(self, result):
        if result:

            self.session.open(TryQuitMainloop, 3)
        else:
            self.close(True)

    def keyClose(self):
        for x in self['config'].list:
            x[1].cancel()

        self.close(False)


class sgrabberScreenGrabberView(Screen):

    def __init__(self, session):
        nowService = session.nav.getCurrentlyPlayingServiceReference()
        self.nowService = nowService
        self.srvName = ServiceReference(session.nav.getCurrentlyPlayingServiceReference()).getServiceName()
        session.nav.stopService()
        tcmd = ''
        if config.plugins.sgrabber.items.value == '-v':
            items = '-v'
        elif config.plugins.sgrabber.items.value == '-o':
            items = '-o'
        else:
            items = ''
        newsize = config.plugins.sgrabber.newsize.value.replace('Disabled', '')
        format = config.plugins.sgrabber.format.value
        fixedaspectratio = config.plugins.sgrabber.fixedaspectratio.value.replace('Disabled', '')
        always43 = config.plugins.sgrabber.always43.value.replace('Disabled', '')
        bicubic = config.plugins.sgrabber.bicubic.value.replace('Disabled', '')
        tcmd = items + ' ' + newsize + ' ' + format + ' ' + fixedaspectratio + ' ' + always43 + ' ' + bicubic
        print(tcmd)
        self.pictureformat = ''
        if format == '-p':
            self.pictureformat = '/tmp/ScreenGrabber.png'
        else:
            self.pictureformat = '/tmp/ScreenGrabber.jpg'
        # r = popen('grab ' + tcmd + ' ' + self.pictureformat).readlines()
        w = getDesktop(0).size().width()
        h = getDesktop(0).size().height()
        PreviewString = '<screen backgroundColor="#00080808" flags="wfNoBorder" position="center,center" size="' + str(w) + ',' + str(h) + '" title="Preview">\n'
        PreviewString += ' <widget name="Picture" position="0,0" size="' + str(w) + ',' + str(h) + '" zPosition="5" alphatest="on" />\n'
        PreviewString += ' <eLabel font="Regular;24" backgroundColor="#00640808" halign="left" valign="center" position="10,80" size="300,25" text="Please wait....." zPosition="1"/>\n'
        PreviewString += ' <eLabel font="Regular;24" backgroundColor="#00080808" halign="left" valign="center" position="10,50" size="620,25" text="OK=Save        Exit=Play TV        Green=Setup        Yellow=Files" zPosition="9"/>\n'
        PreviewString += '</screen>'
        prvScreen = PreviewString
        self.skin = prvScreen
        Screen.__init__(self, session)
        self.session = session
        self.whatPic = self.pictureformat
        self.EXscale = AVSwitch().getFramebufferScale()
        self.EXpicload = ePicLoad()
        self['Picture'] = Pixmap()
        self['actions'] = ActionMap(['WizardActions', 'ColorActions'], {'ok': self.SavePic,
                                                                        'back': self.dexit,
                                                                        'green': self.showsetup,
                                                                        'yellow': self.showfiles}, -1)
        self.EXpicload.PictureData.get().append(self.DecodeAction)
        self.onLayoutFinish.append(self.Show_Picture)

    def showsetup(self):
        self.session.open(sgrabberScreenGrabberSetup)
        self.dexit()

    def showfiles(self):
        self.session.open(sgrabberFilesScreen)
        self.dexit()

    def dexit(self):
        self.session.nav.playService(self.nowService)
        self.close()

    def Show_Picture(self):
        if fileExists(self.whatPic):
            self.EXpicload.setPara([self['Picture'].instance.size().width(),
                                    self['Picture'].instance.size().height(),
                                    self.EXscale[0],
                                    self.EXscale[1],
                                    0,
                                    1,
                                    '#00080808'])
            self.EXpicload.startDecode(self.whatPic)

    def DecodeAction(self, pictureInfo=''):
        if fileExists(self.whatPic):
            ptr = self.EXpicload.getData()
            self['Picture'].instance.setPixmap(ptr)

    def SavePic(self):
        import datetime
        now = datetime.datetime.now()
        day = str(now.day)
        month = str(now.month)
        year = str(now.year)
        hour = str(now.hour)
        second = str(now.second)
        datestr = day + month + year + '-' + hour + second
        srootfolder = config.plugins.sgrabber.storedir.value
        if fileExists(self.whatPic):
            srvName = ServiceReference(self.session.nav.getCurrentlyPlayingServiceReference()).getServiceName()
            srvName = srvName.replace('\xc2\x86', '').replace('\xc2\x87', '')
            srvName = srvName.replace(' ', '_')
            print("264", srootfolder)
            if srootfolder == 'tmp':
                srootfolder = 'tmp'
            elif srootfolder == 'usb':
                srootfolder = 'media/usb'
            elif srootfolder == 'hdd':
                srootfolder = 'media/hdd'
            else:
                self.session.open(MessageBox, text=_('Location not available!'), type=MessageBox.TYPE_ERROR, timeout=5, close_on_any_key=True)
                return
        if path.exists("/" + srootfolder + "/screenshots/"):
            self.folder = "/" + srootfolder + "/screenshots/"
        else:
            success = makedir("/" + srootfolder + "/screenshots/")
            if success is True:
                self.folder = "/" + srootfolder + "/screenshots/"
            else:
                self.folder = "/" + srootfolder + "/"

        print("275", srootfolder, self.folder)
        try:
            if path.exists(self.folder):
                if self.pictureformat.endswith('jpg'):
                    filename = self.folder + self.srvName + '-' + datestr + '.jpg'
                else:
                    filename = self.folder + self.srvName + '-' + datestr + '.png'
                # command = 'cp ' + self.pictureformat + ' ' + filename
                # mtext = 'saving picture to...\n' + filename
                copyfile(self.pictureformat, filename)
                self.session.open(MessageBox, text=_("Screenshot saved to " + filename), type=MessageBox.TYPE_INFO, timeout=3, close_on_any_key=True)
            else:
                self.session.open(MessageBox, text=_('Location not available!'), type=MessageBox.TYPE_ERROR, timeout=5, close_on_any_key=True)
        except:
            self.session.open(MessageBox, text=_('Failed saving file!'), type=MessageBox.TYPE_ERROR, timeout=5, close_on_any_key=True)

        self.dexit()


class classScreenGrabber:

    def __init__(self):
        self.dialog = None
        return

    def gotSession(self, session):
        global globalActionMap
        rcbutton = config.plugins.sgrabber.scut.value
        ScreenGrabber_keymap = '/usr/lib/enigma2/python/Plugins/Extensions/ScreenGrabber/keymaps/' + rcbutton + '_keymap.xml'
        self.session = session
        readKeymap(ScreenGrabber_keymap)
        globalActionMap.actions['ShowScreenGrabber'] = self.ShowHide

    def ShowHide(self):
        self.session.open(sgrabberScreenGrabberView)


pScreenGrabber = classScreenGrabber()


def main(session, **kwargs):
    session.open(sgrabberScreenGrabberSetup)


def sessionstart(reason, **kwargs):
    if reason == 0:
        if config.plugins.sgrabber.items.value == 'Disabled':
            pass
        else:
            pScreenGrabber.gotSession(kwargs['session'])


def Plugins(**kwargs):
    list = []
    list.append(PluginDescriptor(where=[PluginDescriptor.WHERE_SESSIONSTART], fnc=sessionstart))
    list.append(PluginDescriptor(icon='screengrabber.png', name='ScreenGrabber', description='Grab screen image V.%s' % currversion, where=PluginDescriptor.WHERE_PLUGINMENU, fnc=main))
    return list
